<?php

namespace Drupal\health_check_url\Routing;

use Symfony\Component\Routing\Route;
use Symfony\Component\Routing\RouteCollection;
use Drupal\Core\Config\ConfigFactoryInterface;

class RouteService {

  /**
   * The stream wrapper manager service.
   *
   * @var \Drupal\Core\Config\ImmutableConfig
   */
  protected $settings;

  /**
   * @param \Drupal\Core\Config\ConfigFactoryInterface $config_factory
   *   The config factory.
   */
  public function __construct(ConfigFactoryInterface $config_factory) {
    $this->settings = $config_factory->get('health_check_url.settings');
  }

  /**
   * {@inheritdoc}
   */
  public function routes() {
    $route_collection = new RouteCollection();

    $endpoint = !empty($this->settings->get('endpoint')) ? trim($this->settings->get('endpoint'),'/') : 'health';
    $type = $this->settings->get('type');

    $route = new Route(
      '/' . $endpoint,
      [
        '_controller' => '\Drupal\health_check_url\Controller\HealthCheckController::' . $type,
        '_title' => 'Health Check'
      ],
      [
        '_access'  => 'TRUE',
      ]
    );

    $route_collection->add('health_check_url.content', $route);

   $route = new Route(
        '/admin/config/development/health',
        [
          '_form' => '\Drupal\health_check_url\Form\HealthCheckSettingsForm',
          '_title' => 'Health Check URL settings'
        ],
        [
          '_permission'  => 'health_check_url administration',
        ]
      );
  $route_collection->add('health_check_url.admin', $route);
    return $route_collection;
  }

}
